
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *liaKD_class;
void *liaKD_class;

// typedef struct _liaKD {
typedef struct _liaKD {

  t_object  x_obj;

// pd code: 
//   t_float raideur, viscosite, D2, longueur, distance_old, position1,  position2, position_old1, position_old2;
  float raideur, viscosite, D2, longueur, distance_old, position1,  position2, position_old1, position_old2;

// pd code: 
//   t_outlet *force1;
  void *force1;

// pd code: 
//   t_outlet *force2;
  void *force2;

// pd code: 
//   t_float Lmin, Lmax;
  float Lmin, Lmax;
  t_symbol *x_sym;  // receive
} t_liaKD;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void liaKD_float(t_liaKD *x, double f1);
void liaKD_bang(t_liaKD *x);
void liaKD_reset(t_liaKD *x);
void liaKD_resetF(t_liaKD *x);
void liaKD_resetl(t_liaKD *x);
void liaKD_setL(t_liaKD *x, double L);
void liaKD_setK(t_liaKD *x, double K);
void liaKD_setD(t_liaKD *x, double D);
void liaKD_setD2(t_liaKD *x, double D2);
void liaKD_Lmin(t_liaKD *x, double Lmin);
void liaKD_Lmax(t_liaKD *x, double Lmax);
void liaKD_free(t_liaKD *x,t_symbol *s);
void liaKD_position2(t_liaKD *x, double f1);
void liaKD_tellmeeverything(t_liaKD *x);

// added by hand
// void *liaKD_new(t_symbol *s, float L, float K, float D, float D2 );
void *liaKD_new(t_symbol *s, long ac, t_atom *av);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----


// pd code: 
// void liaKD_float(t_liaKD *x, t_floatarg f1)
void liaKD_float(t_liaKD *x, double f1)
{
  x->position1 = f1;
}


// added by hand
void liaKD_position2(t_liaKD *x, double f1)
{
  x->position2 = f1;
}

void liaKD_bang(t_liaKD *x)
{

// pd code: 
//   t_float force1, force2, distance;
  float force1, force2, distance;

// 	post("lia received bang...",0);

  distance = (x->position2 - x->position1);
//distance = abs(x->position2 - x->position1);
  if (distance<0) distance = -distance;

  force1 =  x->raideur*(distance-(x->longueur)) + x->viscosite*(distance - x->distance_old) ;

  x->distance_old = distance;  

  if (distance > x->Lmax) force1=0;
  if (distance < x->Lmin) force1=0;

   if (distance != 0)
  {
    force1 = force1 * (x->position2 - x->position1) / distance;
  }

  force2 = -force1 + (x->position_old2 - x->position2)*x->D2;
  force1 += (x->position_old1 - x->position1)*x->D2;
  // masse damping

  outlet_float(x->force1, force1);
  outlet_float(x->force2, force2);
  
 
  x->position_old1 = x->position1;
  x->position_old2 = x->position2;

}

void liaKD_reset(t_liaKD *x)
{
  x->position1 = 0;
  x->position2 = 0;

  x->position_old1 = 0;
  x->position_old2 = 0;

  x->distance_old = x->longueur;
}

void liaKD_resetF(t_liaKD *x)
{
  x->position_old1 = x->position1;
  x->position_old2 = x->position2;

  x->distance_old = x->longueur;
}

void liaKD_resetl(t_liaKD *x)
{
  x->longueur = (x->position1 - x->position2);
}


// pd code: 
// void liaKD_setL(t_liaKD *x, t_float L)
void liaKD_setL(t_liaKD *x, double L)
{
  x->longueur = L;
}


// pd code: 
// void liaKD_setK(t_liaKD *x, t_float K)
void liaKD_setK(t_liaKD *x, double K)
{
  x->raideur = K;
}


// pd code: 
// void liaKD_setD(t_liaKD *x, t_float D)
void liaKD_setD(t_liaKD *x, double D)
{
  x->viscosite = D;
}


// pd code: 
// void liaKD_setD2(t_liaKD *x, t_float D2)
void liaKD_setD2(t_liaKD *x, double D2)
{
  x->D2 = D2;
}


// pd code: 
// void liaKD_Lmin(t_liaKD *x, t_float Lmin)
void liaKD_Lmin(t_liaKD *x, double Lmin)
{
  x->Lmin = Lmin;
}


// pd code: 
// void liaKD_Lmax(t_liaKD *x, t_float Lmax)
void liaKD_Lmax(t_liaKD *x, double Lmax)
{
  x->Lmax = Lmax;
}

void liaKD_tellmeeverything(t_liaKD *x)
{
  post ("position1: %f", x->position1);
  post ("position2: %f", x->position2);
  post ("longeur: %f", x->longueur);
  post ("K: %f",x->raideur);
  post ("D: %f",x->viscosite);
  post ("D2: %f",x->D2);
}

static void liaKD_free(t_liaKD *x,t_symbol *s)
{

// s->s_thing = 0;
// pd code: 
//     pd_unbind(&x->x_obj.ob_pd, x->x_sym);
    // pb_unbind(&x->x_obj.ob_pd, x->x_sym);
}


// pd code: 
// void *liaKD_new(t_symbol *s, t_floatarg L, t_floatarg K, t_floatarg D, t_floatarg D2 )

// changed by hand:
//void *liaKD_new(t_symbol *s, float L, float K, float D, float D2 )
void *liaKD_new(t_symbol *s, long ac, t_atom *av)
{

// added by hand:  
float L, K, D, D2;

// pd code: 
//   t_liaKD *x = (t_liaKD *)pd_new(liaKD_class);
  t_liaKD *x = (t_liaKD *)newobject(liaKD_class);

// x->x_sym = s;

// pd code: 
//   pd_bind(&x->x_obj.ob_pd, s);

/// s->s_thing = &x->x_obj;

//commented by ali
//floatinlet_new(&x->x_obj, &x->position2);
floatin(x,1);

// pd code: ***UNCHANGED*** 
//   x->force1=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->force2=outlet_new(&x->x_obj, 0);
x->force2=outlet_new(&x->x_obj, 0);
x->force1=outlet_new(&x->x_obj, 0);


//added by hand
  L = (ac && av->a_type == A_FLOAT) ? av->a_w.w_float : 0.;
  K = (ac > 0 && (av + 1)->a_type == A_FLOAT) ? (av + 1)->a_w.w_float : 0.;
  D = (ac > 1 && (av + 2)->a_type == A_FLOAT) ? (av + 2)->a_w.w_float : 0.;
  D2 = (ac > 2 && (av + 3)->a_type == A_FLOAT) ? (av + 3)->a_w.w_float : 0.;



  x->position1 = 0;
  x->position2 = 0;
 
  x->raideur=K;
  x->viscosite=D;
  x->D2=D2;

  x->Lmin= 0;
  x->Lmax= 10000;

  x->longueur=L;

  return (void *)x;
}


// pd code: 
// void lia_setup(void) 
void main(void)
{
/* pd code:
  liaKD_class = class_new(gensym("lia"),
        (t_newmethod)liaKD_new,
        (t_method)liaKD_free,
		sizeof(t_liaKD),
        CLASS_DEFAULT, A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
*/

//setup((t_messlist **) & liaKD_class,(method)liaKD_new,0L,sizeof(t_liaKD),0L, A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
//setup((t_messlist **) &liaKD_class, (method)liaKD_new,	(method)liaKD_free, sizeof(t_liaKD), 0L, A_DEFSYM, A_GIMME, 0);
setup((t_messlist **) &liaKD_class, (method)liaKD_new, (method)liaKD_free, (short)sizeof(t_liaKD), 0L, A_DEFSYM, A_GIMME, 0);


// pd code: 
//   class_addcreator((t_newmethod)liaKD_new, gensym("link"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
  // class_addcreator ((t_newmethod)liaKD_new, gensym("link"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addcreator((t_newmethod)liaKD_new, gensym("pmpd.link"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
  // class_addcreator ((t_newmethod)liaKD_new, gensym("pmpd.link"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);


// pd code: 
//   class_addfloat(liaKD_class, liaKD_float);
addfloat((method)liaKD_float);

// added by hand:
addftx((method)liaKD_position2,1);

// pd code: 
//   class_addbang(liaKD_class, liaKD_bang);
addbang((method)liaKD_bang);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_reset, gensym("reset"), 0);
addmess((method)liaKD_reset, "reset", 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_resetl, gensym("resetL"), 0);
addmess((method)liaKD_resetl, "resetL", 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_resetF, gensym("resetF"), 0);
addmess((method)liaKD_resetF, "resetF", 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_setD, gensym("setD"), A_DEFFLOAT, 0);
addmess((method)liaKD_setD, "setD", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_setD2, gensym("setD2"), A_DEFFLOAT, 0);
addmess((method)liaKD_setD2, "setD2", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_setK, gensym("setK"), A_DEFFLOAT, 0);
addmess((method)liaKD_setK, "setK", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_setL, gensym("setL"), A_DEFFLOAT, 0);
addmess((method)liaKD_setL, "setL", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_Lmin, gensym("setLmin"), A_DEFFLOAT, 0);
addmess((method)liaKD_Lmin, "setLmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(liaKD_class, (t_method)liaKD_Lmax, gensym("setLmax"), A_DEFFLOAT, 0);
addmess((method)liaKD_Lmax, "setLmax", A_DEFFLOAT, 0);


addmess((method)liaKD_tellmeeverything, "tellmeeverything", 0);

}
