
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *masse_class;
void *masse_class;

typedef struct _masse {
  t_object  x_obj;

// pd code: 
//   t_float pos_old_1, pos_old_2, Xinit;
  float pos_old_1, pos_old_2, Xinit;

// pd code: 
//   t_float force, masse, dX;
  float force, masse, dX;

// pd code: 
//   t_float minX, maxX;
  float minX, maxX;

// pd code: 
//   t_outlet *position_new, *vitesse_out, *force_out;
  void *position_new, *vitesse_out, *force_out;
  t_symbol *x_sym; // receive
} t_masse;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
//float max(float x, double y);
//float min(float x, double y);
void masse_minX(t_masse *x, double f1);
void masse_maxX(t_masse *x, double f1);
void masse_float(t_masse *x, double f1);
void masse_bang(t_masse *x);
void masse_reset(t_masse *x);
void masse_resetF(t_masse *x);
void masse_dX(t_masse *x, double posX);
void masse_setX(t_masse *x, double posX);
void masse_loadbang(t_masse *x);
void masse_set_masse(t_masse *x, double mass);
void masse_free(t_masse *x);
void *masse_new(t_symbol *s, double M, double X);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----


// pd code: 
// extern t_float max(t_float, t_float);

// pd code: 
// extern t_float min(t_float, t_float);

//added by hand...
//float max(float x, double y)
//{
//    if (x >= y)
//    {
//        return x;
//    }
//    return y;
//}
//
//float min(float x, double y)
//{
//    if (x <= y)
//    {
//        return x;
//    }
//    return y;
//}
// ...added by hand


// pd code: 
// void masse_minX(t_masse *x, t_floatarg f1)
void masse_minX(t_masse *x, double f1)
{
  x->minX = f1;
}


// pd code: 
// void masse_maxX(t_masse *x, t_floatarg f1)
void masse_maxX(t_masse *x, double f1)
{
  x->maxX = f1;
}


// pd code: 
// void masse_float(t_masse *x, t_floatarg f1)
void masse_float(t_masse *x, double f1)
{
  x->force += f1;
}

void masse_bang(t_masse *x)
{

// pd code: 
//   t_float pos_new;
  float pos_new;

	if (x->masse > 0)
  pos_new = x->force/x->masse + 2*x->pos_old_1 - x->pos_old_2;
	else pos_new = x->pos_old_1;

  pos_new = max(min(x->maxX, pos_new), x->minX);

  pos_new += x->dX;

  x->pos_old_1 += x->dX; // pour ne pas avoir d'inertie suplementaire du a ce deplacement
 
  outlet_float(x->vitesse_out, x->pos_old_1 - x->pos_old_2);
  outlet_float(x->force_out, x->force);
  outlet_float(x->position_new, pos_new);

  x->pos_old_2 = x->pos_old_1;
  x->pos_old_1 = pos_new;

  x->force = 0;
  x->dX = 0;

}

void masse_reset(t_masse *x)
{
  x->pos_old_2 = x->Xinit;
  x->pos_old_1 = x->Xinit;

  x->force=0;

  outlet_float(x->position_new, x->Xinit);
}

void masse_resetF(t_masse *x)
{
  x->force=0;
}


// pd code: 
// void masse_dX(t_masse *x, t_float posX)
void masse_dX(t_masse *x, double posX)
{
  x->dX += posX;
}


// pd code: 
// void masse_setX(t_masse *x, t_float posX)
void masse_setX(t_masse *x, double posX)
{
  x->pos_old_2 = posX;			// clear hystory for stability (instability) problem
  x->pos_old_1 = posX;

  x->force=0;

  outlet_float(x->position_new, posX);
}

void masse_loadbang(t_masse *x)
{
  outlet_float(x->position_new, x->Xinit);
}


// pd code: 
// void masse_set_masse(t_masse *x, t_float mass)
void masse_set_masse(t_masse *x, double mass)
{
  x->masse=mass;
}

static void masse_free(t_masse *x)
{

// pd code: 
//     pd_unbind(&x->x_obj.ob_pd, x->x_sym);
    // pb_unbind(&x->x_obj.ob_pd, x->x_sym);
}


// pd code: 
// void *masse_new(t_symbol *s, t_floatarg M, t_floatarg X)
void *masse_new(t_symbol *s, double M, double X)
{
  

// pd code: 
//   t_masse *x = (t_masse *)pd_new(masse_class);
  t_masse *x = (t_masse *)newobject(masse_class);

  x->x_sym = s;

// pd code: 
//   pd_bind(&x->x_obj.ob_pd, s);
s->s_thing = &x->x_obj;


// pd code: ***UNCHANGED*** 
//   x->position_new=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->force_out=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->vitesse_out=outlet_new(&x->x_obj, 0); 


//added by hand:
  x->vitesse_out=outlet_new(&x->x_obj, 0); 
  x->force_out=outlet_new(&x->x_obj, 0);
  x->position_new=outlet_new(&x->x_obj, 0);
  
  
  x->Xinit=X;

  x->pos_old_1 = X;
  x->pos_old_2 = X;
  x->force=0;
  x->masse=M;

  x->minX = -100000;
  x->maxX = 100000;

  if (x->masse<=0) x->masse=1;

  return (void *)x;
}


// pd code: 
// void masse_setup(void) 
void main(void)
{

/* pd code:
  masse_class = class_new(gensym("masse"),
        (t_newmethod)masse_new,
        (t_method)masse_free,
		sizeof(t_masse),
        CLASS_DEFAULT, A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT,0);
*/
setup((t_messlist **) &   masse_class,(method)masse_new,0L,sizeof(t_masse),0L, A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT,0);

// pd code: 
//   class_addcreator((t_newmethod)masse_new, gensym("mass"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT,0);
  // class_addcreator ((t_newmethod)masse_new, gensym("mass"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT,0);

// pd code: 
//   class_addcreator((t_newmethod)masse_new, gensym("pmpd.mass"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT,0);
  // class_addcreator ((t_newmethod)masse_new, gensym("pmpd.mass"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT,0);

// pd code: 
//   class_addfloat(masse_class, masse_float);
addfloat((method)masse_float);

// pd code: 
//   class_addbang(masse_class, masse_bang);
addbang((method)masse_bang);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_set_masse, gensym("setM"), A_DEFFLOAT, 0);
addmess((method)masse_set_masse, "setM", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_setX, gensym("setX"), A_DEFFLOAT, 0);
addmess((method)masse_setX, "setX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_dX, gensym("dX"), A_DEFFLOAT, 0);
addmess((method)masse_dX, "dX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_reset, gensym("reset"), 0);
addmess((method)masse_reset, "reset", 0);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_resetF, gensym("resetF"), 0);
addmess((method)masse_resetF, "resetF", 0);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_minX, gensym("setXmin"), A_DEFFLOAT, 0);
addmess((method)masse_minX, "setXmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_maxX, gensym("setXmax"), A_DEFFLOAT, 0);
addmess((method)masse_maxX, "setXmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(masse_class, (t_method)masse_loadbang, gensym("loadbang"), 0);
addmess((method)masse_loadbang, "loadbang", 0);
}

