
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *tSeg2D_class;
void *tSeg2D_class;

typedef struct _tSeg2D {
  t_object  x_obj;

// pd code: 
//   t_float  X1, X2, Y1, Y2, P, P_old;
  float  X1, X2, Y1, Y2, P, P_old;

// pd code: 
//   t_outlet *force_new, *profondeur, *vitesse;// outlet
  void *force_new, *profondeur, *vitesse;// outlet
} t_tSeg2D;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void tSeg2D_position2D(t_tSeg2D *x, double X, double Y);
void tSeg2D_Xmin(t_tSeg2D *x, double X);
void tSeg2D_Xmax(t_tSeg2D *x, double X);
void tSeg2D_Ymin(t_tSeg2D *x, double X);
void tSeg2D_Ymax(t_tSeg2D *x, double X);
void tSeg2D_P(t_tSeg2D *x, double X);
void *tSeg2D_new(t_symbol *s, int argc, t_atom *argv);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----


// pd code: 
// void tSeg2D_position2D(t_tSeg2D *x, t_float X, t_float Y)
void tSeg2D_position2D(t_tSeg2D *x, double X, double Y)
{

// pd code: 
// 	t_float a1, b1, c1, a2, b2, c2, a3, b3, c3, profondeur, tmp;
	float a1, b1, c1, a2, b2, c2, a3, b3, c3, profondeur, tmp;

	b1 = x->X2 - x->X1;
	a1 = -x->Y2 + x->Y1;

	if (!((a1==0) & (b1==0)))
	{
		tmp = sqrt((a1*a1)+(b1*b1));			// = longueur du vecteur pour renormalisation
		a1 = a1/tmp;
		b1 = b1/tmp;
		c1 = a1*x->X1+b1*x->Y1;

		profondeur = ( (a1 * X)  + (b1 *   Y) )  - c1;
	
		tmp = profondeur - x->P_old;

		x->P_old = profondeur;

		a2 = b1;
		b2 = -a1;
		c2 = a2*x->X1+b2*x->Y1;

		a3 = a2;
		b3 = b2;
		c3 = a3*x->X2+b3*x->Y2;

		outlet_float(x->vitesse, tmp);
		outlet_float(x->profondeur, profondeur);

		if ( ( profondeur  < 0) & (profondeur >  - x->P)  & (( (a2 * X)  + (b2 *   Y) )  > c2) & ( ((a3 * X)  + (b3 * Y) )  < c3) )
		{
		outlet_float(x->force_new, 1);
		}
		else
		{
		outlet_float(x->force_new, 0);
		}
	}
	else
	{
	outlet_float(x->force_new, 0);
	}

}


// pd code: 
// void tSeg2D_Xmin(t_tSeg2D *x, t_float X)
void tSeg2D_Xmin(t_tSeg2D *x, double X)
{
   x->X1= X;
}


// pd code: 
// void tSeg2D_Xmax(t_tSeg2D *x, t_float X)
void tSeg2D_Xmax(t_tSeg2D *x, double X)
{
   x->X2= X;
}


// pd code: 
// void tSeg2D_Ymin(t_tSeg2D *x, t_float X)
void tSeg2D_Ymin(t_tSeg2D *x, double X)
{
   x->Y1= X;
}


// pd code: 
// void tSeg2D_Ymax(t_tSeg2D *x, t_float X)
void tSeg2D_Ymax(t_tSeg2D *x, double X)
{
   x->Y2= X;
}


// pd code: 
// void tSeg2D_P(t_tSeg2D *x, t_float X)
void tSeg2D_P(t_tSeg2D *x, double X)
{
   x->P= X;
}

void *tSeg2D_new(t_symbol *s, int argc, t_atom *argv)
{

// pd code: 
//   t_tSeg2D *x = (t_tSeg2D *)pd_new(tSeg2D_class);
  t_tSeg2D *x = (t_tSeg2D *)newobject(tSeg2D_class);

// pd code: ***UNCHANGED*** 
//   x->force_new = outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->profondeur =outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->vitesse = outlet_new(&x->x_obj, 0);
x->vitesse = outlet_new(&x->x_obj, 0);
x->profondeur =outlet_new(&x->x_obj, 0);
x->force_new = outlet_new(&x->x_obj, 0);

  x->P_old = 0;

  if (argc>=5)
    x->P = atom_getfloatarg(4, argc, argv);
  else
    x->P = 1;

    if (argc>=4)
    x->Y2 = atom_getfloatarg(3, argc, argv);
  else
    x->Y2 = 0;

  if (argc>=3)
    x->X2 = atom_getfloatarg(2, argc, argv);
  else
    x->X2 = 1;

  if (argc>=2)
    x->Y1 = atom_getfloatarg(1, argc, argv);
  else
    x->Y1 = 0;

  if (argc>=1)
    x->X1 = atom_getfloatarg(0, argc, argv);
  else
    x->X1 = -1;

  return (x);
}


// pd code: 
// void tSeg2D_setup(void) 
void main(void)
{

// pd code 
/*
  tSeg2D_class = class_new(gensym("tSeg2D"),
        (t_newmethod)tSeg2D_new,
        0, sizeof(t_tSeg2D),
        CLASS_DEFAULT, A_GIMME, 0);*/
setup((t_messlist **) &tSeg2D_class,(method)tSeg2D_new,0,(short)sizeof(t_tSeg2D),0L, A_GIMME,0);



// pd code: 
//   class_addcreator((t_newmethod)tSeg2D_new, gensym("pmpd.tSeg2D"), A_GIMME, 0);
  // class_addcreator ((t_newmethod)tSeg2D_new, gensym("pmpd.tSeg2D"), A_GIMME, 0);


// pd code: 
//   class_addmethod(tSeg2D_class, (t_method)tSeg2D_position2D, gensym("position2D"), A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)tSeg2D_position2D, "position2D", A_DEFFLOAT, A_DEFFLOAT, 0);


// pd code: 
//   class_addmethod(tSeg2D_class, (t_method)tSeg2D_Xmin, gensym("setX1"), A_DEFFLOAT, 0);
addmess((method)tSeg2D_Xmin, "setX1", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSeg2D_class, (t_method)tSeg2D_Ymin, gensym("setY1"), A_DEFFLOAT, 0);
addmess((method)tSeg2D_Ymin, "setY1", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSeg2D_class, (t_method)tSeg2D_Xmax, gensym("setX2"), A_DEFFLOAT, 0);
addmess((method)tSeg2D_Xmax, "setX2", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSeg2D_class, (t_method)tSeg2D_Ymax, gensym("setY2"), A_DEFFLOAT, 0);
addmess((method)tSeg2D_Ymax, "setY2", A_DEFFLOAT, 0);

// pd code: 
//  class_addmethod(tSeg2D_class, (t_method)tSeg2D_P, gensym("setPmax"), A_DEFFLOAT, 0);
addmess((method)tSeg2D_P, "setPmax", A_DEFFLOAT, 0);

}
