
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *tSphere3D_class;
void *tSphere3D_class;

typedef struct _tSphere3D {
  t_object  x_obj;

// pd code: 
//   t_float  X, Y, Z, Rmin, Rmax, position_old;
  float  X, Y, Z, Rmin, Rmax, position_old;

// pd code: 
//   t_outlet *force_new, *distance_out, *vitesse;// outlet
  void *force_new, *distance_out, *vitesse;// outlet
} t_tSphere3D;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void tSphere3D_position3D(t_tSphere3D *x, double X,  float Y, double Z);
void tSphere3D_setXYZ(t_tSphere3D *x, double X, double Y, double Z);
void tSphere3D_setX(t_tSphere3D *x, double X);
void tSphere3D_setY(t_tSphere3D *x, double Y);
void tSphere3D_setZ(t_tSphere3D *x, double Z);
void tSphere3D_setRmax(t_tSphere3D *x, double X);
void tSphere3D_setRmin(t_tSphere3D *x, double X);
void *tSphere3D_new(t_symbol *s, int argc, t_atom *argv);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----


// pd code: 
// void tSphere3D_position3D(t_tSphere3D *x, t_float X,  t_float Y, t_float Z)
void tSphere3D_position3D(t_tSphere3D *x, double X,  float Y, double Z)
{

// pd code: 
// t_float  distance, vitesse;
float  distance, vitesse;
		distance = sqrt ( (X - x->X)*(X - x->X) + (Y - x->Y)*(Y - x->Y) + (Z - x->Z)*(Z - x->Z));

		vitesse = distance - x->position_old;
		x->position_old = distance;

		outlet_float(x->vitesse, vitesse);

		outlet_float(x->distance_out, distance);

		if ( (distance < x->Rmax) & (distance > x->Rmin) )
		{
			outlet_float(x->force_new, 1);
		}
		else
		{
			outlet_float(x->force_new, 0);
		}

}


// pd code: 
// void tSphere3D_setXYZ(t_tSphere3D *x, t_float X, t_float Y, t_float Z)
void tSphere3D_setXYZ(t_tSphere3D *x, double X, double Y, double Z)
{
  x->X= X;
  x->Y= Y;
  x->Z= Z;
}


// pd code: 
// void tSphere3D_setX(t_tSphere3D *x, t_float X)
void tSphere3D_setX(t_tSphere3D *x, double X)
{
  x->X= X;
}


// pd code: 
// void tSphere3D_setY(t_tSphere3D *x, t_float Y)
void tSphere3D_setY(t_tSphere3D *x, double Y)
{
  x->Y= Y;
}


// pd code: 
// void tSphere3D_setZ(t_tSphere3D *x, t_float Z)
void tSphere3D_setZ(t_tSphere3D *x, double Z)
{
  x->Z= Z;
}


// pd code: 
// void tSphere3D_setRmax(t_tSphere3D *x, t_float X)
void tSphere3D_setRmax(t_tSphere3D *x, double X)
{
  x->Rmax= X;
}


// pd code: 
// void tSphere3D_setRmin(t_tSphere3D *x, t_float X)
void tSphere3D_setRmin(t_tSphere3D *x, double X)
{
  x->Rmin= X;
}



void *tSphere3D_new(t_symbol *s, int argc, t_atom *argv)
{

// pd code: 
//   t_tSphere3D *x = (t_tSphere3D *)pd_new(tSphere3D_class);
  t_tSphere3D *x = (t_tSphere3D *)newobject(tSphere3D_class);


// pd code: ***UNCHANGED*** 
//   x->force_new=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->distance_out=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->vitesse=outlet_new(&x->x_obj, 0);

x->vitesse=outlet_new(&x->x_obj, 0);
x->distance_out=outlet_new(&x->x_obj, 0);
x->force_new=outlet_new(&x->x_obj, 0);
    
  x->position_old = 0;


    if (argc>=5)
    x->Rmax= atom_getfloatarg(4, argc, argv);
  else
    x->Rmax= 1;

  if (argc>=4)
    x->Rmin= atom_getfloatarg(3, argc, argv);
  else
    x->Rmin= 0;

  if (argc>=3)
    x->Z= atom_getfloatarg(2, argc, argv);
  else
	x->Z= 0;

  if (argc>=2)
    x->Y= atom_getfloatarg(1, argc, argv);
  else
	x->Y= 0;

  if (argc>=1)
	x->X= atom_getfloatarg(0, argc, argv);
  else
	x->X= 0;

  return (x);
}


// pd code: 
// void tSphere3D_setup(void) 
void main(void)
{

// pd code 
/*
  tSphere3D_class = class_new(gensym("tSphere3D"),
        (t_newmethod)tSphere3D_new,
        0, sizeof(t_tSphere3D),
        CLASS_DEFAULT, A_GIMME, 0);*/
setup((t_messlist **) &tSphere3D_class,(method)tSphere3D_new,0,(short)sizeof(t_tSphere3D),0L, A_GIMME,0);



// pd code: 
//   class_addcreator((t_newmethod)tSphere3D_new, gensym("pmpd.tSphere3D"),  A_GIMME, 0);
  // class_addcreator ((t_newmethod)tSphere3D_new, gensym("pmpd.tSphere3D"),  A_GIMME, 0);
 

// pd code: 
//   class_addmethod(tSphere3D_class, (t_method)tSphere3D_position3D, gensym("position3D"), A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)tSphere3D_position3D, "position3D", A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);


// pd code: 
//   class_addmethod(tSphere3D_class, (t_method)tSphere3D_setX, gensym("setX"), A_DEFFLOAT, 0);
addmess((method)tSphere3D_setX, "setX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSphere3D_class, (t_method)tSphere3D_setY, gensym("setY"), A_DEFFLOAT, 0);
addmess((method)tSphere3D_setY, "setY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSphere3D_class, (t_method)tSphere3D_setZ, gensym("setZ"), A_DEFFLOAT, 0);
addmess((method)tSphere3D_setZ, "setZ", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSphere3D_class, (t_method)tSphere3D_setXYZ, gensym("setXYZ"), A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)tSphere3D_setXYZ, "setXYZ", A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSphere3D_class, (t_method)tSphere3D_setRmax, gensym("setRmax"), A_DEFFLOAT, 0);
addmess((method)tSphere3D_setRmax, "setRmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSphere3D_class, (t_method)tSphere3D_setRmin, gensym("setRmin"), A_DEFFLOAT, 0);
addmess((method)tSphere3D_setRmin, "setRmin", A_DEFFLOAT, 0);


}
